# Adblock Plus core

[![Contributor Covenant](https://img.shields.io/badge/Contributor%20Covenant-2.1-4baaaa.svg)](./CODE_OF_CONDUCT.md)

This repository contains the generic Adblock Plus code that's shared between
platforms. This repository is __not designed to be used directly__, but instead
to serve as a dependency for `adblockpluschrome` and `libadblockplus`.

## Contributing

Please follow the [code style](docs/CODE_STYLE.md). Most of the rules
are enforced by the linter (see below).

## Code of Conduct

All contributors to this project are required to read, and follow, our
[code of conduct](./CODE_OF_CONDUCT.md).

## Resources

One of the feature of Adblock Plus is to allow redirecting requests to
inactive versions of a resource (script, image, or media).

To that effect we have some resources generated as data built into
Adblock Plus.

As there is no "build" for adblockplsucore, if you want to modify
these resources, you'll need to regenerate the file
`data/resources.js`.

Adding the new resource for `$redirect`:

* Edit `data/resources/index.json`. The fields are defined as follow:
  * `name`: The name of the resource as used for the `$rewrite` filter option.
  * `type`: The MIME type of the content.
  * `text`: If the resource is pure text, you can use this for the text
    content. If the resource is binary data, use `file` instead.
  * `file`: The name of the file in `build/assets/` that will be included
    in the output as base64. If there is a `text` value, don't include this.
  * `comment`: an optional comment. This won't be part of the output.
* Add the binary files referenced in the `file` entry for the new resource in
  `data/resources/`. They should be checked into the repository.
* Run the `resources` package script using npm with the command
  `npm run uppdate-resources`. This will generate the file
  `data/resources.js`. This file is also managed by the version control
  system and should be part of the checkin.

## Running the unit tests

### Requirements

In order to run the unit test suite you need
[Node.js 18 or higher](https://nodejs.org/). Once Node.js is installed
please run `npm install` in the repository directory in order to install the
required dependencies.

### Running unit tests

`npm run test:unit` will run unit tests in the `test` directory of the
repository.

### Running browser tests

The tests under `test/browser` require a browser environment.
`npm run test:browser` will run these in a headless browser, with each module
being loaded in a new frame.

By default tests run in the latest versions of Chromium and Firefox. The
`CHROMIUM_VERSION` and `FIREFOX_VERSION` environment variables can be set to
change the running browser versions.

If you want to disable headless mode on the browser tests, set the
`BROWSER_TEST_HEADLESS` environment variable to 0.

## Linting

You can lint the code using [ESLint](http://eslint.org) by running
`npm run lint`.

## Documentation

The module documentation is generated with `jsdoc`. To generate the
documentation use:

```sh
npm run docs
```

The documentation generated by the CI is available [here](https://eyeo.gitlab.io/adblockplus/abc/webext-ad-filtering-solution/adblockpluscore/index.html)

## Node.js module

adblockpluscore is available as an npm module for Node.js. See:
    <https://www.npmjs.com/package/adblockpluscore>

You can install it with:

```sh
npm install adblockpluscore
```

Or you can simply add it to your `package.json`.

```javascript
let {contentTypes, FilterEngine} = require("adblockpluscore");

async function main()
{
  let filterEngine = new FilterEngine();

  await filterEngine.initialize(
    [
      "/annoying-ad.$image",
      "||example.com/social-widget.html^"
    ]
  );

  let resource = {
    url: "https://ad-server.example.net/annoying-ad.png",
    documentURL: "https://news.example.com/world.html"
  };

  let filter = filterEngine.match(resource.url, contentTypes.IMAGE,
                                  new URL(resource.documentURL).hostname);
  console.log(filter); // prints "/annoying-ad.$image"
}

if (require.main == module)
  main();
```
